$hauteur = 20; // dimension
$largeur = 0.25 * $hauteur;
$largeurbord = 0.15; // largeur de bordure relative (1 = 100%, 0.5 = 50%, ...) 
$transparence = 0.8;
$nb_trous = 4; // 1 à 8 trous
$niveau_detail = 3; // 1 à 3 niveaux de détails
$couvert = false; // true pour avoir un bouchon; false sans bouchon.


module maincyl(){

    if ($niveau_detail == 1){
        color("white", $transparence)
cylinder(h = $hauteur, $fn = 5, r = $largeur);};
    if ($niveau_detail == 2){
        color("white", $transparence)
cylinder(h = $hauteur, $fn = 10, r = $largeur);};
    if ($niveau_detail == 3){
        color("white", $transparence)
cylinder(h = $hauteur, $fn = 50, r = $largeur);};

};

module smallcyl(){
    if ($niveau_detail == 2) {
    color("white", $transparence)
cylinder(h = $hauteur * 0.3, $fn = 10, r1 = $largeur * 0.8,r2 = $largeur * 0.7);};
    if ($niveau_detail == 3) {
    color("white", $transparence)
cylinder(h = $hauteur * 0.3, $fn = 50, r1 = $largeur * 0.8,r2 = $largeur * 0.7);};
}

module cone(){
    if ($niveau_detail == 2){
        color("white", $transparence)
        cylinder(h = 0.1 * $hauteur, r1 = $largeur, r2 = $largeur * 0.8, $fn = 10);};
    if ($niveau_detail == 3){
        color("white", $transparence)
        cylinder(h = 0.1 * $hauteur, r1 = $largeur, r2 = $largeur * 0.8, $fn = 50);};
        };
  
  
module maincyl_inter(){
    if ($niveau_detail == 1){
    cylinder(h = $hauteur * 0.95, $fn = 5, r = $largeur * (1 - $largeurbord));}
    if ($niveau_detail == 2){
    cylinder(h = $hauteur * 0.95, $fn = 10, r = $largeur * (1 - $largeurbord));}
    if ($niveau_detail == 3){
    cylinder(h = $hauteur * 0.95, $fn = 50, r = $largeur * (1 - $largeurbord));}
    };
    
module smallcyl_inter(){
    if ($niveau_detail == 2){
    cylinder(h = $hauteur * 0.32, $fn = 10, r1 = $largeur * 0.8 * (1 - $largeurbord), r2 = $largeur * 0.7 * (1 - $largeurbord));}
    if ($niveau_detail == 3){
    cylinder(h = $hauteur * 0.32, $fn = 50, r1 = $largeur * 0.8 * (1 - $largeurbord), r2 = $largeur * 0.7 * (1 - $largeurbord));}
    
    };
    
module cone_inter(){
    if ($niveau_detail == 2){
        cylinder(h = $hauteur * 0.12, r1 = $largeur * (1 - $largeurbord), r2 = $largeur  * 0.8 * (1 - $largeurbord), $fn = 10) ; };
    if ($niveau_detail == 3){
        cylinder(h = $hauteur * 0.12, r1 = $largeur * (1 - $largeurbord), r2 = $largeur  * 0.8 * (1 - $largeurbord), $fn = 50) ; };
    
    
  };
  
module simple_cyl(){
    if ($niveau_detail == 1){
    color("white",$transparence)
    translate([0,0,$hauteur * 0.999])
    cylinder(h = $hauteur * 0.4, r1 = $largeur * 1.01, r2 = $largeur * 0.7, $fn = 5);}
};

module simple_cyl_inter(){
    if ($niveau_detail == 1){
        translate([0,0,$hauteur * 0.998])
        cylinder(h = $hauteur * 0.405, r1 = $largeur * (1 - $largeurbord), r2 = $largeur * 0.7 * (1 - $largeurbord), $fn = 5);
        
        
        };};
module holes(){
   
    if ($nb_trous > 8) {
        for (i = [0 : 7]){
        translate([$largeur * 0.8 * sin(360/    8 * i),$largeur * 0.8 * cos(360/8 * i),$hauteur * 0.2])
        rotate([-90,0,-360/8 * i])
        cylinder(h = $largeur * 0.3, r = $hauteur / 25, $fn = 50);};
        
        }
    ;
     
    if ($nb_trous < 1){
        translate([0,$largeur * 0.8 ,$hauteur * 0.2])
        rotate([-90,0,0])
        cylinder(h = $largeur * 0.3, r = $hauteur/25, $fn = 50);};
        
        
    
    if ($nb_trous >= 1 && $nb_trous <= 8){
        for (i = [0 : $nb_trous - 1]){
            translate([$largeur * 0.8 * sin(360/    $nb_trous * i),$largeur * 0.8 * cos(360/$nb_trous * i),$hauteur * 0.2])
            rotate([-90,0,-360/$nb_trous * i])
            cylinder(h = $largeur * 0.3, r = $hauteur/25, $fn = 50);};};
    
    
    
    
    //translate([$largeur * 0.8,0,$hauteur * 0.2])
    //rotate([0,90,0])
    //cylinder(h = $largeur * 0.3, r = 2, $fn = 50);
    //translate([-$largeur * 0.8,0,$hauteur * 0.2])
    //rotate([0,-90,0])
    //cylinder(h = $largeur * 0.3, r = 2, $fn = 50);
    //translate([0,-$largeur * 0.8,$hauteur * 0.2])
    //rotate([90,0,0])
    //cylinder(h = $largeur * 0.3, r = 2, $fn = 50);
    //translate([0,$largeur * 0.8,$hauteur * 0.2])
    //rotate([-90,0,0])
    //cylinder(h = $largeur * 0.3, r = 2, $fn = 50);
    };

//minkowski(){


module bouchon(){
    if ($niveau_detail == 1){
        color("red",1)
    translate([0,0,1.3 * $hauteur])
    cylinder(h = $hauteur * 0.1, r = 0.8 * $largeur,$fn = 5);
        };
    if ($niveau_detail == 2) {
        color("red",1)
    translate([0,0,1.3 * $hauteur])
    cylinder(h = $hauteur * 0.1, r = 0.8 * $largeur,$fn = 10);
        };
    if ($niveau_detail == 3) {
        color("red",1)
    translate([0,0,1.3 * $hauteur])
    cylinder(h = $hauteur * 0.1, r = 0.8 * $largeur,$fn = 50);
        };
    
    
    
};




module main(){
    difference(){
        union(){  
            maincyl();
            translate([0,0,$hauteur*0.999])cone();
            translate([0,0,$hauteur*1.099])smallcyl();
            simple_cyl();
        };
//};

        translate([0,0,$hauteur * 0.1]) maincyl_inter();
        translate([0,0,$hauteur * 1.089])       smallcyl_inter();
        translate([0,0,$hauteur * 0.989]) cone_inter();
        simple_cyl_inter();
        holes();
    };
    if ($couvert){
        bouchon();
    };
};


main();
